#include <GenericTypeDefs.h>
#include <p18f2321.h>
#include "PinDefs.h"
#include <delays.h>


extern volatile unsigned char BPsys;
extern volatile unsigned char BPsys_max;
extern volatile unsigned char BPdia;
extern volatile unsigned char BPdia_max;
extern volatile unsigned char raw[40];
extern volatile unsigned char press[40];
extern volatile unsigned char press_temp;
extern volatile unsigned char raw1[11];
extern volatile unsigned char count;
extern volatile unsigned char overthresh;//1 ascending peak, 0 = descending peak
extern volatile unsigned char state; 
extern volatile unsigned char BPmap;
extern volatile unsigned char Tcount;

BYTE_VAL BPmap_out;
//volatile unsigned int press[30];
    #define del  12

void dispMap(void);
void dispDia(void);
void dispSys(void);
void dispDia_max(void);
void dispSys_max(void);


void dispSys_max(void)
{
	unsigned char i = 0;

	thresh = 0;
	BPhigh = 0;
	BPgood = 0;
	Delay10KTCYx (2*del);
	BPmap_out.Val = BPsys_max;
	thresh = 0;
	BPhigh = 1;
	BPgood = 1;
	Delay10KTCYx (2*del);   
    thresh = 1;
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b7);
	Delay10KTCYx (del);
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (del);
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b6);
	Delay10KTCYx (del);
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (del);
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b5);
	Delay10KTCYx (del);
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (del);
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b4);
	Delay10KTCYx (del);
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (del);
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b3);
	Delay10KTCYx (del);
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (del);
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b2);
	Delay10KTCYx (del);
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (del);
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b1);
	Delay10KTCYx (del);
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (del);
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b0);
	Delay10KTCYx (del);
    thresh = 0;
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (5*del);
}


void dispDia_max(void)
{
	unsigned char i = 0;

	thresh = 0;
	BPhigh = 0;
	BPgood = 0;
	Delay10KTCYx (2*del);
	BPmap_out.Val = BPdia_max;
	thresh = 0;
	BPhigh = 1;
	BPgood = 1;
	Delay10KTCYx (2*del);   
    thresh = 1;
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b7);
	Delay10KTCYx (del);
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (del);
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b6);
	Delay10KTCYx (del);
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (del);
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b5);
	Delay10KTCYx (del);
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (del);
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b4);
	Delay10KTCYx (del);
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (del);
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b3);
	Delay10KTCYx (del);
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (del);
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b2);
	Delay10KTCYx (del);
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (del);
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b1);
	Delay10KTCYx (del);
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (del);
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b0);
	Delay10KTCYx (del);
    thresh = 0;
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (5*del);
}




void dispMap(void)
{
	unsigned char i = 0;

	thresh = 0;
	BPhigh = 0;
	BPgood = 0;
	Delay10KTCYx (2*del);
	BPmap_out.Val = BPmap;
	thresh = 0;
	BPhigh = 1;
	BPgood = 1;
	Delay10KTCYx (2*del);   
    thresh = 1;
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b7);
	Delay10KTCYx (del);
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (del);
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b6);
	Delay10KTCYx (del);
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (del);
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b5);
	Delay10KTCYx (del);
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (del);
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b4);
	Delay10KTCYx (del);
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (del);
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b3);
	Delay10KTCYx (del);
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (del);
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b2);
	Delay10KTCYx (del);
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (del);
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b1);
	Delay10KTCYx (del);
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (del);
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b0);
	Delay10KTCYx (del);
    thresh = 0;
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (5*del);
}


void dispDia(void)
{
	unsigned char i = 0;

	thresh = 0;
	BPhigh = 0;
	BPgood = 0;
	Delay10KTCYx (2*del);
	BPmap_out.Val = BPdia;
	thresh = 0;
	BPhigh = 1;
	BPgood = 1;
	Delay10KTCYx (2*del);   
    thresh = 1;
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b7);
	Delay10KTCYx (del);
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (del);
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b6);
	Delay10KTCYx (del);
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (del);
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b5);
	Delay10KTCYx (del);
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (del);
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b4);
	Delay10KTCYx (del);
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (del);
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b3);
	Delay10KTCYx (del);
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (del);
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b2);
	Delay10KTCYx (del);
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (del);
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b1);
	Delay10KTCYx (del);
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (del);
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b0);
	Delay10KTCYx (del);
    thresh = 0;
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (5*del);
}


void dispSys(void)
{
	unsigned char i = 0;

	thresh = 0;
	BPhigh = 0;
	BPgood = 0;
	Delay10KTCYx (2*del);
	BPmap_out.Val = BPsys;
	thresh = 0;
	BPhigh = 1;
	BPgood = 1;
	Delay10KTCYx (2*del);   
    thresh = 1;
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b7);
	Delay10KTCYx (del);
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (del);
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b6);
	Delay10KTCYx (del);
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (del);
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b5);
	Delay10KTCYx (del);
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (del);
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b4);
	Delay10KTCYx (del);
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (del);
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b3);
	Delay10KTCYx (del);
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (del);
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b2);
	Delay10KTCYx (del);
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (del);
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b1);
	Delay10KTCYx (del);
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (del);
	BPgood = 0;
	BPhigh = !(BPmap_out.bits.b0);
	Delay10KTCYx (del);
    thresh = 0;
	BPgood = 1;
	BPhigh = 1;
	Delay10KTCYx (5*del);
}