#include <p18f2321.h>
#include "PinDefs.h"
#include <timers.h>

void setupTmrs(void);
void tmr0(void);
void InterruptHandlerHigh (void);
void InterruptVectorHigh (void);
extern unsigned char Tcount;

void setupTmrs(void)
{
	T0CON = 0; //Sets time to 16 bit mode and transistion on internal clock
	T0CONbits.PSA = 1; //Ignore prescaler for now
	TMR0H = 0x7D;
	TMR0L = 0x00;
	//Enable Timer 0 interrupt
    INTCONbits.TMR0IE = 1;


                                                                     
                                             
	INTCONbits.TMR0IF = 0; //Clear Interrupt Flag
	INTCONbits.TMR0IE = 1; //Enable Interrupt
	RCONbits.IPEN = 1;            //enable priority levels

	T0CONbits.T08BIT = 1; // set as 8 bit (0 means 16 bit)
	T0CONbits.T0CS = 0;   //Use the system clock
	//T0CON.T0SE = 0;   //Don't Care
	T0CONbits.PSA = 0;   //No Prescaler
	T0CONbits.T0PS2 = 0;
	T0CONbits.T0PS1 = 1;
	T0CONbits.T0PS0 = 1;
	//T0CON.T0PS = 0b001;   //Don't Care (prescaler)
	INTCONbits.GIEH = 1;          //enable interrupts
	T0CONbits.TMR0ON = 1; //Turn on timer

	


}

//----------------------------------------------------------------------------
// High priority interrupt vector

#pragma code InterruptVectorHigh = 0x08
void
InterruptVectorHigh (void)
{
  _asm
    goto InterruptHandlerHigh //jump to interrupt routine
  _endasm
}

//----------------------------------------------------------------------------
// High priority interrupt routine

#pragma code
#pragma interrupt InterruptHandlerHigh

void
InterruptHandlerHigh ()
{
  if (INTCONbits.TMR0IF)
    {                                   //check for TMR0 overflow
      INTCONbits.TMR0IF = 0;            //clear interrupt flag
	  if (Tcount < 100)
	  {
		Tcount++;
		power = 1;
	  }
	  else
	  {
		Tcount = 0;
		power = 0;
	  }

    }

}